- name: "Sets Source PVC & Job Name Facts"
  set_fact:
    job_name: "{{ (db_host ~ '-' ~ (snap_mark | default('default')) ~ '-reset') }}"
    source_pvc: "{{ (src_pvc | default('')) if (src_pvc is defined)
                                          else
                 (db_host ~ '-' ~ (snap_mark | default('default')) ~ '-snap') }}"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - name: "{{ job_name }}"
    policy_name: "{{ job_name }}-to-{{ db_host }}"
    policy_state: "{{ 'present' if (do_network_policy)
                                else 'absent' }}"
    subject: "{{ db_host }}"
    to:
    - number: "3306"
- include_role:
    name: commons
    tasks_from: helpers/job.yaml
  vars:
    job_args: |
      echo "Starting import on $(date +%s)";
      if test "$DEBUG"; then
          set -x;
      fi;
      if ! test -s "/backup/$MYSQL_DB.sql"; then
          echo "CRITICAL: backup not found";
          exit 1;
      fi;
      cpt=0;
      while test "$cpt" -lt 10; do
          if cat "/backup/$MYSQL_DB.sql" | mysql "-u$MYSQL_USER" "-p$MYSQL_PASS" "-h$MYSQL_HOST" "-P3306" "$MYSQL_DB"; then
              break;
          fi;
          cpt=$(expr $cpt + 1);
          sleep 10;
      done;
      if test "$cpt" -ge 10; then
          echo "failed importing backup, bailing out on $(date +%s)";
          exit 1;
      fi;
      echo "successfully imported mysql:$MYSQL_HOST:$MYSQL_DB on $(date +%s)";
      exit 0;
    job_backoff_limit: 5
    job_env:
    - name: DEBUG
      value: "{{ 'yes' if (do_debugs) else '' }}"
    - name: MYSQL_DB
      secret_key: database-name
      secret_name: "{{ db_secret_name }}"
    - name: MYSQL_HOST
      value: "{{ db_host ~ ('-client' if (is_cluster | default(False)) else '') }}"
    - name: MYSQL_PASS
      secret_key: database-password
      secret_name: "{{ db_secret_name }}"
    - name: MYSQL_USER
      secret_key: database-user
      secret_name: "{{ db_secret_name }}"
    job_image: "{{ (opsimages | json_query(\"[?name=='backups'].image\"))[0] }}"
    job_volumes:
    - kind: PersistentVolumeClaim
      name: "{{ source_pvc }}"
      path: /backup
- include_role:
    name: commons
    tasks_from: helpers/wait-for.yaml
  vars:
    check_with: "{{ lookup('k8s', api_version='batch/v1', kind='Job',
                           resource_name=job_name,
                           namespace=namespace) | default('') }}"
    obj_name: "{{ job_name }}"
    retries_for: "{{ (import_wait_retries | default(60)) | int }}"
    wait_for: "{{ (import_wait_for | default(10)) | int }}"
  when:
  - job_wait_completion | default(True)
